#!/usr/bin/python



import sys


def get_record(file):
	read=[]
	for x in range(4):
		read.append(file.readline().strip())
		if not read[-1]:
			return None
	return read
	
def check_qual(s,threshold,fraction):
	return sum(map(lambda x : max(min(ord(x) - 33 - threshold ,1),0), s)) > len(s)/2

def usage():
	print "%s input_fastq_filename output_filename [number of reads=100] [threshold=20] [fraction=0.5]" % sys.argv[0]

if __name__=='__main__':
	if len(sys.argv)>6 or len(sys.argv)<3:
		usage()
		sys.exit(1)	
	number_of_reads=100
	threshold=20
	fraction=0.5
	if len(sys.argv)==6:
		fraction=float(sys.argv[5])
	if len(sys.argv)>=5:
		threshold=int(sys.argv[4])
	if len(sys.argv)>=4:
		number_of_reads=int(sys.argv[3])
	output_filename=sys.argv[2]
	input_fq_filename=sys.argv[1]
	
	input_fq_file=open(input_fq_filename,'rU')
	output_file=open(output_filename,'w')
	current=get_record(input_fq_file)
	number_of_reads_out=0
	while (current and number_of_reads_out<number_of_reads):
		if check_qual(current[3],threshold,fraction):
			print >> output_file, "\n".join(current)
			number_of_reads_out+=1	
		current=get_record(input_fq_file)
	if number_of_reads_out<number_of_reads:
		print >> sys.stderr, "There are not enough reads! Only printed %d of the %d requested." % (number_of_reads_out,number_of_reads)
	input_fq_file.close()
	output_file.close()
